{% extends "front/base_logged.html" %}
{% load i18n %}

{% block content %}

    {% include "wizard/header.html" %}

    <div class="panel panel-default">
      <div class="panel-heading">
          <strong>{% trans "Selecionar Modelo" %}</strong>
          <div class="help">
              <button id="help_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Mais info' %}" data-title="{% trans 'Mais info' %}" data-title_alt="{% trans 'Menos info' %}">
                  <span class="glyphicon glyphicon-question-sign"></span>
              </button>
              <button id="tips_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Dicas' %}">
                  <span class="glyphicon glyphicon-info-sign"></span>
              </button>
          </div>
      </div>
      <div id="help" class="alert alert-warning cst_hide">
         {% include "wizard/help_text/step_model.html" %}
      </div>
      <div class="panel-body">
        {% blocktrans trimmed %}
          Este Assistente de Configuração tem por objetivo a montagem de um sistema de previsão em tempo real numa área à sua escolha.
          Neste passo terá de escolher o tipo de corrida, o modelo a utilizar e o periodo de tempo a prever diariamente.
          Os tipos de corrida 3D requerem permissões avançadas.
        {% endblocktrans %}
      </div>
    </div>

    {% if errors %}
    <div class="alert alert-danger">
        <ul>
            {% for error in errors %}
            <li>{{ error }}</li>
            {% endfor %}
        </ul>
    </div>
    {% endif %}

    <form class="form" method="post">{% csrf_token %}
        <strong>{% trans "Selecione tipo de corrida:" %}</strong>
        <div id="form_div">
            {% include "front/form.html" %}
        </div>
        <div class="row btnmenu">
            <div class="col-xs-6">
            </div>
            <div class="col-xs-6 text-right">
                {% if not request.session.last_step %}
                <button id="btn_submit" type="submit" name="edit" class="btn btn-primary" data-step="2" data-intro="{% trans 'E prima o botão para continuar' %}">
                    {% trans "Concluir passo" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
                {% else %}
                <button id="btn_next" class="btn btn-default">
                    {% trans "Seguinte" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
                {% endif %}
            </div>
        </div>
    </form>

    {% if disclaimer %}
    {% include "front/modal/disclaimer_accept.html" %}
    {% endif %}

    <script type="text/javascript">
        // Tooltips Setup (for Intro.js)
        $('#form_div').attr("data-step", 1);
        {% if not request.session.last_step %}
        $('#form_div').attr("data-intro", "{% trans 'Neste passo preencha o formulário' %}");
        {% else %}
        $('#form_div').attr("data-intro", "{% trans 'Este passo já foi concluido e não permite alterações.' %}");
        {% endif %}

        // Submit Step event
        $('#btn_submit').click(function(e){
            var flagok = true;
            var msg = '{% trans "Para continuar terá de preencher os campos obrigatórios (*)." %}';
            // Validate form
            $('.form input, .form select').each(function(){
                if ($(this).prop('required') && $(this).val() == '') {
                    flagok = false;
                    return false;
                }
            });

            if (!flagok) {
                $('#msg_str').html(msg);
                $('#divModal_msg').modal('show');
                return false;
            }
        });

        function disableWaterQualityChoice(e){
            let baroclinic_childs = document.getElementById("baroclinic_choice").getElementsByTagName('li');
            let wq_childs = document.getElementById("wq_choice").getElementsByTagName('li');

            if(baroclinic_childs[0].childNodes[0].childNodes[0].checked) {
                for(var i = 0; i < wq_childs.length; i++) {
                    var wq_child = wq_childs[i].childNodes[0].childNodes[0];

                    if(wq_child.checked)
                        wq_child.checked = false;
                }

                wq_childs[0].childNodes[0].childNodes[0].checked = true;

                for(var j = 0; j < wq_childs.length; j++)
                    wq_childs[j].childNodes[0].childNodes[0].disabled = true;
            }
            else if(baroclinic_childs[0].childNodes[0].childNodes[0].disabled) {
                for(var i = 0; i < wq_childs.length; i++)
                    wq_childs[i].childNodes[0].childNodes[0].disabled = true;
            }
            else {
                for(var i = 0; i < wq_childs.length; i++)
                    wq_childs[i].childNodes[0].childNodes[0].disabled = false;
            }
        }

        // On Document Ready
        $(function(){
            {% if disclaimer %}
            $('#divModal_disclaimer_accept').modal();
            {% endif %}

            // Accept Disclaimer action
            $('#btn_disclaimer').click(function(e){
                $.ajax({
                    type: 'GET',
                    url: '{% url 'wizard:accept_disclaimer' %}',
                    success: function(data) {
                        if (data["done"]) {
                            // Show Tips
                            intro.start();
                        }
                    },
                    error: function(e, x, r) {
                        console.log(r + ' - ' + e);
                    }
                });
                e.preventDefault();
            });

            // Fill Periods Select according to chosen Model
            $("#id_model").change(function(e) {
                if ($(this).val()) {
                    //Fill Periods from ModelVersion selection
                    $.ajax({
                        type: 'GET',
                        url: '{% url 'wizard:get_run_periods' mv_pk=0 %}'.replace(/0/, $(this).val()),
                        success: function(response) {
                            // Remove all options except empty
                            $('select[name=run_period] option').each(function() {
                                if ($(this).val() != "") $(this).remove();
                            });

                            // Add new options if any
                            var data = response['data'];
                            for (i=0; i<data.length; i++) {
                                $('select[name=run_period]').append(
                                    $('<option>', {
                                        value: data[i].value,
                                        text: data[i].text
                                    }, '</option>')
                                );
                            }

                            // Allow changing values
                            $('#id_run_period').removeAttr("disabled");
                        },
                        error: function(e, x, r) {
                            console.log(r + ' - ' + e);
                        }
                    });
                } else {
                    // Remove options not in the returned data (all periods are loaded on server-side on init)
                    $('select[name=run_period]').val('');
                    // Disallow changing values
                    $('#id_run_period').attr("disabled", "");
                }
                e.preventDefault();
            });
            disableWaterQualityChoice(document.getElementById("baroclinic_choice"));
        });
    </script>
{% endblock content %}
